/**
  ******************************************************************************
  * @file    signal_processing.h
  * @author  Brian Mazzeo
  * @date    2020
  * @brief   This file provides a set of code for signal processing in 487.
  *          Parts are taken from example code from STMIcroelectronics
  ******************************************************************************
  * @attention
  *          This code was specifically developed for BYU ECEn 487 course 
  *          Introduction to Digital Signal Processing.
  *
  *
  ******************************************************************************
  */ 

#include "mbed.h"
#include "stm32746g_discovery_lcd.h"


void initalize_signal_processing(void);
void process_audio_channel_signals(float32_t* L_channel_in, float32_t* R_channel_in, float32_t* L_channel_out, float32_t* R_channel_out, uint16_t Signal_Length);

void filter_conv_init();
void filter_fft_init();

void filter_OA_CONV(float32_t* overlap_buffer, float32_t* d_in, float32_t* d_out, uint16_t sig_length);
void filter_OA_FFT(float32_t* overlap_buffer, float32_t* fft_buffer, float32_t* ifft_buffer, float32_t* d_in, float32_t* d_out, uint16_t sig_length);
void filter_OA_FFT_RI(float32_t* overlap_buffer1, float32_t* overlap_buffer2, float32_t* fft_buffer, float32_t* ifft_buffer, float32_t* d_in1, float32_t* d_in2, float32_t* d_out1, float32_t* d_out2, uint16_t sig_length);
void filter_OS_FFT_RI(float32_t* save_buffer1, float32_t* save_buffer2, float32_t* fft_buffer, float32_t* ifft_buffer, float32_t* d_in1, float32_t* d_in2, float32_t* d_out1, float32_t* d_out2, uint16_t sig_length);